/* %W%   %G% */
#define MACHEPS 0.000000000000001   /* machine precision */

void gradient(double *p, double *g, int nparms);

void numgrad(int nparms, double *invals, double *grads, double *wrk,
		double (*func)(double *));
void numgradc(int nparms, double *invals, double *grads, double *wrk,
		double (*func)(double *));

double *numopgc(int nparms, int nobs, double *invals, double *opg, double *wrk,
		int (*func)(double *X, double *outvec));

double **eaccuracy(int nparms, int ndiffs, double h, double *invals,
		   double *wrk, double (*func)(double *));

struct estints {
  int nparms;
  int *errors;  /* 0 == OK, >=1 == error */
  double
    *hf,   /* interval */
    *phi,  /* f' (first derivative) */
    *phic,  /* f' (first derivative, central-difference) */
    *phi2, /* f'' (second derivative) */
    *ef,   /* error bound */
    *hessian;  /* hessian matrix (lower triangle) */
};

struct estints *algfd(int nparms, double *eps, double *invals, double *wrk,
		      double (*func)(double *));
void fdestimates(int parm, double fvalue, double *invals, double *wrk,
		 double eps, double h,
		 double *fplus, double *fminus,
		 double *phif, double *phib, double *phic, double *phi2,
		 double *cf, double *cb, double *c2,
		 double (*func)(double *));

struct estints *numhessian(struct estints *instruc, double *invals, double *wrk,
			   double (*func)(double *));
struct estints *numhessianc(struct estints *instruc, double *invals, double *wrk,
			   double (*func)(double *));

void estoptint(int nparms, int ndiffs, int pflag, double *invals,
		double (*func)(double *));
void dohessians(int nparms, int nobs, int ndiffs, double *invals,
		double (*func)(double *), double (*funco)(double *, double *));
